#ifndef _FRIDGE_DATA_STRUCTURES_H_
#define _FRIDGE_DATA_STRUCTURES_H_

#include <linux/types.h>
#include <linux/spinlock.h>

#define HASH_TABLE_LENGTH 17

/*
 * A key-value pair.
 */
struct kkv_pair {
	char *value;
	uint32_t key;
	size_t size;
};

/*
 * A node in a linked list.  Contains a key-value pair.
 */
struct kkv_ht_entry {
	struct list_head entries;
	struct kkv_pair kv_pair;
};

/*
 * A bucket in the hash table. 
 * The hash table is an array of HASH_TABLE_LENGTH buckets.
 */
struct kkv_ht_bucket {
	spinlock_t lock;
	struct list_head entries;
	uint32_t count;
};

#endif
